DEFINT A-Z
'$INCLUDE: '..\include\Declare.bi'
'$INCLUDE: '..\include\future.bi'
'$INCLUDE: '..\include\Const.bi'
'$INCLUDE: '..\include\share.bi'

SUB drawborder (X, Y, X1, Y1, cu AS LONG, cf AS LONG, cd AS LONG)
CALL Future.FILLBOX(X + 1, Y + 1, X1 - 1, Y1 - 1, cf)

CALL Future.LINE(X, Y, X1, Y, cu, -1)
CALL Future.LINE(X, Y, X, Y1, cu, -1)

CALL Future.LINE(X, Y1, X1, Y1, cd, -1)
CALL Future.LINE(X1, Y, X1, Y1, cd, -1)

END SUB

SUB drawFrame (X, Y, X1, Y1, cu AS LONG, cd AS LONG)
CALL Future.LINE(X, Y, X1, Y, cu, -1)
CALL Future.LINE(X, Y, X, Y1, cu, -1)
CALL Future.LINE(X, Y1, X1, Y1, cd, -1)
CALL Future.LINE(X1, Y, X1, Y1, cd, -1)
END SUB

SUB drawpicto (X, Y, XL, n, UC AS LONG, BC AS LONG, Tc AS LONG, DC AS LONG)

CALL Future.FILLBOX(X + 1, Y + 1, X + XL - 1, Y + XL - 1, BC)
CALL Future.LINE(X, Y, X + XL, Y, UC, -1)
CALL Future.LINE(X, Y, X, Y + XL, UC, -1)

CALL Future.LINE(X, Y + XL, X + XL, Y + XL, DC, -1)
CALL Future.LINE(X + XL, Y, X + XL, Y + XL, DC, -1)




SELECT CASE n
CASE 0
CASE 1  'close
CALL Future.LINE(X + 2, Y + 2, X + XL - 2, Y + XL - 2, Tc, -1)
CALL Future.LINE(X + 2, Y + XL - 2, X + XL - 2, Y + 2, Tc, -1)


IF XL > 10 THEN
CALL Future.LINE(X + 3, Y + 2, X + XL - 2, Y + XL - 3, Tc, -1)
CALL Future.LINE(X + 2, Y + XL - 3, X + XL - 3, Y + 2, Tc, -1)
CALL Future.LINE(X + 2, Y + 3, X + XL - 3, Y + XL - 2, Tc, -1)
CALL Future.LINE(X + 3, Y + XL - 2, X + XL - 2, Y + 3, Tc, -1)
END IF
CASE 2  'max

CALL Future.BOX(X + 2, Y + 2, X + XL - 2, Y + XL - 2, Tc)

IF XL > 10 THEN
CALL Future.BOX(X + 2, Y + 3, X + XL - 2, Y + XL - 2, Tc)
'CALL Future.FillBox(X + 2, Y + 4, X + XL - 2, Y + XL - 2, TC)
END IF
CASE 3  'Default
IF XL >= 10 THEN
CALL Future.BOX(X + 1, Y + XL - 2, X + XL / 2 + 1, Y + XL / 2 - 2, Tc)
CALL Future.BOX(X + XL / 2 - 2, Y + XL / 2 + 2, X + XL - 2, Y + 2, Tc)
END IF

IF XL < 10 THEN
CALL Future.BOX(X + 1, Y + XL - 1, X + XL / 2, Y + XL / 2 - 1, Tc)
CALL Future.BOX(X + XL / 2, Y + XL / 2, X + XL - 2, Y + 1, Tc)

END IF
CASE 4  'Min
IF XL >= 10 THEN
CALL Future.FILLBOX(X + 2, Y + XL - 2, X + XL - 3, Y + XL - 3, Tc)
END IF
IF XL < 10 THEN
CALL Future.LINE(X + 1, Y + XL - 1, X + XL - 2, Y + XL - 1, Tc, -1)
END IF
CASE 5  'Galka
CALL Future.LINE(X + 1, Y + 3, X + XL / 2 - 1, Y + XL / 2 + 1, Tc, -1)
CALL Future.LINE(X + 1, Y + 4, X + XL / 2 - 1, Y + XL / 2 + 2, Tc, -1)
CALL Future.LINE(X + XL / 2 - 1, Y + XL / 2 + 1, X + XL - 2, Y + 2, Tc, -1)
CALL Future.LINE(X + XL / 2 - 1, Y + XL / 2 + 2, X + XL - 2, Y + 3, Tc, -1)

CASE 6  ' circle
CALL Future.FILLCIRCLE(X + XL / 2, Y + XL / 2, XL / 2 - 2, Tc)

CASE 7  'Up
yy = XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
yy = yy + 1
CALL Future.LINE(X - l + XL / 2, Y + yy, X + l + XL / 2, Y + yy, Tc, -1)
NEXT

'CALL FILLAREA(X + XL / 2, Y + XL / 2, TC, TC)
CASE 8  'Down
yy = 2 * XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
yy = yy - 1
CALL Future.LINE(X - l + XL / 2, Y + yy, X + l + XL / 2, Y + yy, Tc, -1)
NEXT

CASE 9  'Left
XX = XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
XX = XX + 1
CALL Future.LINE(X + XX, Y - l + XL / 2, X + XX, Y + l + XL / 2, Tc, -1)
NEXT

CASE 10  'Right
XX = 2 * XL / 3
FOR l = 0 TO FIX(XL / 2) - 2
XX = XX - 1
CALL Future.LINE(X + XX, Y - l + XL / 2, X + XX, Y + l + XL / 2, Tc, -1)
NEXT

CASE 11  'Left\UP
CALL Future.LINE(X + 2, Y + 2, X + 2, Y + XL - 2, Tc, -1)
CALL Future.LINE(X + 2, Y + 2, X + XL - 2, Y + 2, Tc, -1)
CALL Future.LINE(X + XL - 2, Y + 2, X + 2, Y + XL - 2, Tc, -1)
'CALL FILLAREA(X + 3, Y + 3, TC, TC)

END SELECT

END SUB

SUB LoadSystem (XRes, YRes, Bits)
Sys.HeadSize = 20
Sys.MaxX = XRes
Sys.MaxY = YRes
Sys.Font = 1

IF Bits = 8 THEN
Sys.HeadColor = 9
Sys.BColor = 7
Sys.UpColor = 15
Sys.DownColor = 8
Sys.TextBColor = 7
Sys.Bits = Bits
k = 1
END IF
IF Bits = 16 OR Bits = 15 THEN
Sys.HeadColor = RGB2Color(0, 0, 63)'CBrBlue
Sys.BColor = RGB2Color(50, 50, 50)
Sys.UpColor = RGB2Color(63, 63, 63)
Sys.DownColor = RGB2Color(10, 10, 10)
Sys.TextBColor = RGB2Color(55, 55, 55)
Sys.Bits = Bits
k = 1
END IF

IF Bits = 32 THEN
Sys.HeadColor = RGB2Color(0, 0, 220)'CBrBlue
Sys.BColor = RGB2Color(150, 150, 150)
Sys.UpColor = RGB2Color(255, 255, 255)
Sys.DownColor = RGB2Color(100, 100, 100)
Sys.TextBColor = RGB2Color(210, 210, 210)
Sys.Bits = Bits
k = 1
END IF
IF k = 0 THEN
PRINT "Bits parameter must be 8, 15, 16 or 32"
END
END IF
IF k = 1 THEN

IF NOT (IsVESA) THEN
PRINT "Your Video card doesn`t support VESA mode"
END
END IF
IF NOT (IsXMSInstalled) THEN
PRINT "Programm can`t found XMS memory"
END
END IF

CALL SetScreenMode(XRes, YRes, Bits)
END IF
Refreshed = 1
END SUB

SUB MoveControl (id, dx, DY)
DIM cc AS LONG

OBJ = GetProp(id, PObject)
IF OBJ = OForm THEN
XP = GetProp(id, PXPos)
YP = GetProp(id, PYPos)
ELSE
XP = GetProp(id, PRXPos)
YP = GetProp(id, PRYPos)
END IF

XL = GetProp(id, PXLen)
YL = GetProp(id, PYLen)
X = Future.MouseX
Y = Future.MouseY

XM = X
YM = Y

LLX& = SizeOf(XL, 1)
LLY& = SizeOf(1, YL)


H1 = AllocateXMS(LLY&)
H2 = AllocateXMS(LLX&)
H11 = AllocateXMS(LLX&)
H22 = AllocateXMS(LLY&)

CALL Future.XMSget(XP, YP, XP, YP + YL, H1)
CALL Future.XMSget(XP, YP, XP + XL, YP, H2)

CALL Future.XMSget(XP, YP + YL, XP + XL, YP + YL, H11)
CALL Future.XMSget(XP + XL, YP, XP + XL, YP + YL, H22)

Future.MouseOff
MoBu1 = Future.MouseB
cc = Sys.UpColor
DO

CALL Future.LINE(XP - dx, YP - DY, XP - dx, YP + YL - DY, cc, -1)
CALL Future.LINE(XP - dx, YP - DY, XP + XL - dx, YP - DY, cc, -1)

CALL Future.LINE(XP - dx, YP + YL - DY, XP + XL - dx, YP + YL - DY, cc, -1)
CALL Future.LINE(XP + XL - dx, YP - DY, XP + XL - dx, YP + YL - DY, cc, -1)
DX2 = dx
DY2 = DY

DO
Future.UpdateMouse
xm1 = XM
YM1 = YM

XM = Future.MouseX
YM = Future.MouseY
MoBu = Future.MouseB
LOOP UNTIL xm1 <> XM OR YM1 <> YM OR MoBu <> MoBu1
dx = X - XM
DY = Y - YM
CALL Future.XMSput(XP - DX2, YP - DY2, H1)
CALL Future.XMSput(XP - DX2, YP - DY2, H2)

CALL Future.XMSput(XP - DX2, YP + YL - DY2, H11)
CALL Future.XMSput(XP + XL - DX2, YP - DY2, H22)

'CALL future.Line(XP - DX2, YP - DY2, XP - DX2, YP + YL - DY2, CBrWhite, -1)

CALL Future.XMSget(XP - dx, YP - DY, XP - dx, YP + YL - DY, H1)
CALL Future.XMSget(XP - dx, YP - DY, XP + XL - dx, YP - DY, H2)

CALL Future.XMSget(XP - dx, YP + YL - DY, XP + XL - dx, YP + YL - DY, H11)
CALL Future.XMSget(XP + XL - dx, YP - DY, XP + XL - dx, YP + YL - DY, H22)

'   CALL future.Line(XP - DX, YP - DY, XP - DX, YP + YL - DY, CBrWhite, -1)





LOOP UNTIL MoBu <> MoBu1
DeallocateXMS (H1)
DeallocateXMS (H2)
DeallocateXMS (H11)
DeallocateXMS (H22)
Future.MouseOn



END SUB

SUB PrintGfx (X, Y, t$, Tc&, BC&)
CALL Future.PRINT(X, Y, t$, Tc&, BC&)
END SUB

SUB PrintInBox (X, Y, X1, Y1, Text$, Style, Tc AS LONG, BC AS LONG)
TLE = LEN(Text$) * 8
IF CurFontSize > 0 THEN fts = CurFontSize ELSE CurFontSize = 16
IF TLE < X1 - X AND INSTR(1, Text$, CHR$(13)) = 0 THEN
IF Style = 0 THEN
XP = X
YP = Y + ((Y1 - Y) / 2 - fts / 2)
END IF
IF Style = 1 THEN
XP = X + ((X1 - X) / 2 - TLE / 2)
YP = Y + ((Y1 - Y) / 2 - fts / 2)
END IF

CALL PrintGfx(XP, YP, Text$, Tc, BC)
ELSE
yy = Y
I = 1
DO

il = INSTR(I, Text$, CHR$(13)) - I

IF il <= 0 THEN l = (X1 - X) \ 8: Pi = 0
IF il > 0 THEN l = il: Pi = 1

s$ = MID$(Text$, I, l)

IF Style = 0 THEN
XP = X
END IF
IF Style = 1 THEN
XP = X + ((X1 - X) / 2 - l * 8 / 2)
END IF
CALL PrintGfx(XP, yy, s$, Tc, BC)
I = I + l + Pi
yy = yy + fts
LOOP UNTIL I >= TLE
END IF

END SUB

SUB ResizeControl (id, dx, DY)
DIM cc AS LONG

OBJ = GetProp(id, PObject)
IF OBJ = OForm THEN
XP = GetProp(id, PXPos)
YP = GetProp(id, PYPos)
ELSE
XP = GetProp(id, PRXPos)
YP = GetProp(id, PRYPos)
END IF

XL = GetProp(id, PXLen)
YL = GetProp(id, PYLen)
X = Future.MouseX
Y = Future.MouseY

XM = X
YM = Y

LLX& = SizeOf(XL, 1)
LLY& = SizeOf(1, YL)


H1 = AllocateXMS(LLY&)
H2 = AllocateXMS(LLX&)
H11 = AllocateXMS(LLX&)
H22 = AllocateXMS(LLY&)

CALL Future.XMSget(XP, YP, XP, YP + YL, H1)
CALL Future.XMSget(XP, YP, XP + XL, YP, H2)

CALL Future.XMSget(XP, YP + YL, XP + XL, YP + YL, H11)
CALL Future.XMSget(XP + XL, YP, XP + XL, YP + YL, H22)

Future.MouseOff
MoBu1 = Future.MouseB
cc = Sys.UpColor
DO

CALL Future.LINE(XP, YP, XP, YP + YL - DY, cc, -1)
CALL Future.LINE(XP, YP, XP + XL - dx, YP, cc, -1)

CALL Future.LINE(XP, YP + YL - DY, XP + XL - dx, YP + YL - DY, cc, -1)
CALL Future.LINE(XP + XL - dx, YP, XP + XL - dx, YP + YL - DY, cc, -1)
DX2 = dx
DY2 = DY

DO
Future.UpdateMouse
xm1 = XM
YM1 = YM

XM = Future.MouseX
YM = Future.MouseY
MoBu = Future.MouseB
LOOP UNTIL xm1 <> XM OR YM1 <> YM OR MoBu <> MoBu1
dx = X - XM
DY = Y - YM
IF XP + XL - dx < XP THEN dx = XL
IF YP + YL - DY < YP THEN DY = YL



CALL Future.XMSput(XP, YP, H1)
CALL Future.XMSput(XP, YP, H2)

CALL Future.XMSput(XP, YP + YL - DY2, H11)
CALL Future.XMSput(XP + XL - DX2, YP, H22)


CALL Future.XMSget(XP, YP, XP, YP + YL - DY, H1)
CALL Future.XMSget(XP, YP, XP + XL - dx, YP, H2)

CALL Future.XMSget(XP, YP + YL - DY, XP + XL - dx, YP + YL - DY, H11)
CALL Future.XMSget(XP + XL - dx, YP, XP + XL - dx, YP + YL - DY, H22)

LOOP UNTIL MoBu <> MoBu1
DeallocateXMS (H1)
DeallocateXMS (H2)
DeallocateXMS (H11)
DeallocateXMS (H22)
Future.MouseOn



END SUB

SUB ShowControl (id)
DIM Tc AS LONG, BC AS LONG, UC AS LONG, DC AS LONG, HC AS LONG


IF GetProp(id, PNoRefresh) <> 0 OR id = 0 THEN EXIT SUB

OBJ = GetProp(id, PObject)
RVis = GetProp(id, PRVisible)
Vis = GetProp(id, PVisible)

XP = GetProp(id, PXPos)
YP = GetProp(id, PYPos)

XPR = GetProp(id, PRXPos)
YPR = GetProp(id, PRYPos)

XL = GetProp(id, PXLen)
YL = GetProp(id, PYLen)

st = GetProp(id, PStyle)
X = XPR
Y = YPR
X1 = XPR + XL
Y1 = YPR + YL
Tc = GetLProp(id, PTColor)
BC = GetLProp(id, PBColor)
UC = GetLProp(id, PUpColor)
DC = GetLProp(id, PDownColor)
ft = GetLProp(id, PFont)
SetFont ft
IF ft = 0 THEN fts = 8
IF ft = 1 THEN fts = 16
IF ft = 2 THEN fts = 14
CurFontSize = fts
HC = Sys.HeadColor

tit$ = title(id)

TLE = LEN(tit$) * 8

'-------------------------------------------Form------------------------------'-------------------------------------------Form--------------------------------
IF OBJ = OForm AND Vis <> 0 THEN
X1 = XP + XL
Y1 = YP + YL
STa = GetProp(id, PState)
IF id = 1 THEN
Future.CLS BC
CALL drawFrame(XP, YP, X1, Y1, UC, DC)
ELSE
CALL drawborder(XP, YP, X1, Y1, UC, BC, DC)
END IF

IF id = ActiveForm(focus.id) THEN
CALL drawborder(XP, YP, X1, YP + Sys.HeadSize, Sys.UpColor, Sys.HeadColor, Sys.DownColor)
CALL PrintGfx(XP + 3, YP + 3, tit$, Tc, HC)
ELSE
CALL drawborder(XP, YP, X1, YP + Sys.HeadSize, Sys.UpColor, Sys.DownColor, Sys.DownColor)
CALL PrintGfx(XP + 3, YP + 3, tit$, Tc, Sys.DownColor)

END IF
IF (CNoClose AND st) = 0 THEN
CALL drawpicto(X1 - Sys.HeadSize + 2, YP + 2, Sys.HeadSize - 4, 1, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoMax AND st) = 0 AND STa = CDefault THEN
CALL drawpicto(X1 - Sys.HeadSize * 2 + 2, YP + 2, Sys.HeadSize - 4, 2, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoMax AND st) = 0 AND STa = CMax THEN
CALL drawpicto(X1 - Sys.HeadSize * 2 + 2, YP + 2, Sys.HeadSize - 4, 3, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF STa = CMin THEN
CALL drawpicto(X1 - Sys.HeadSize * 2 + 2, YP + 2, Sys.HeadSize - 4, 3, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoMin AND st) = 0 AND STa <> CMin THEN
CALL drawpicto(X1 - Sys.HeadSize * 3 + 4, YP + 2, Sys.HeadSize - 4, 4, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF
IF (CNoResize AND st) = 0 AND STa = CDefault THEN
CALL drawpicto(X1 - 8, Y1 - 8, 8, 11, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF

END IF
'-------------------------------------------Button----------------------------'-------------------------------------------Button----------------------------
IF OBJ = OButton AND RVis <> 0 THEN
IF st AND CCenter THEN s = 1 ELSE s = 0
X = 0
Y = 0
IF GetProp(id, PLMDown) THEN
IF st AND CNoBorder THEN  ELSE CALL drawborder(XPR, YPR, XPR + XL, YPR + YL, DC, BC, UC)
IF st AND CPicture THEN  ELSE CALL PrintInBox(XPR + 4, YPR + 4, X1 - 2, Y1 - 2, tit$, s, Tc, BC)
X = 1
Y = 1
ELSE
IF st AND CNoBorder THEN  ELSE CALL drawborder(XPR, YPR, XPR + XL, YPR + YL, UC, BC, DC)
IF st AND CPicture THEN  ELSE CALL PrintInBox(XPR + 2, YPR + 2, X1 - 2, Y1 - 2, tit$, s, Tc, BC)
END IF

IF st AND CPicture THEN
SetViewPort XPR + 1, YPR + 1, XPR + XL, YPR + YL
X = XPR + 1 + X
Y = YPR + 1 + Y
IF LEN(tit$) > 4 THEN
IF UCASE$(RIGHT$(tit$, 4)) = ".BMP" THEN CALL Future.LoadBMP(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".PCX" THEN CALL Future.LoadPCX(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".GIF" THEN CALL Future.LoadGIF(tit$, X, Y)
END IF
SetViewPort 0, 0, Sys.MaxX, Sys.MaxY
END IF

END IF
'-------------------------------------------Frame----------------------------'-------------------------------------------Frame----------------------------------
IF OBJ = OFrame AND RVis <> 0 THEN
IF st AND CNoBorder THEN  ELSE CALL drawborder(XPR, YPR, XPR + XL, YPR + YL, UC, BC, DC)
IF st AND CCenter THEN s = 1 ELSE s = 0
IF st AND CPicture THEN  ELSE CALL PrintInBox(XPR + 2, YPR + 2, X1 - 2, Y1 - 2, tit$, s, Tc, BC)

IF st AND CPicture THEN
SetViewPort XPR + 1, YPR + 1, XPR + XL, YPR + YL
X = XPR + 1
Y = YPR + 1
IF LEN(tit$) > 4 THEN
IF UCASE$(RIGHT$(tit$, 4)) = ".BMP" THEN CALL Future.LoadBMP(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".PCX" THEN CALL Future.LoadPCX(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".GIF" THEN CALL Future.LoadGIF(tit$, X, Y)
END IF
SetViewPort 0, 0, Sys.MaxX, Sys.MaxY
END IF

END IF
'-------------------------------------------CheckBox----------------------------'-------------------------------------------CheckBox----------------------------
IF OBJ = OCheckBox AND RVis <> 0 THEN
IF st AND CNoBorder THEN
ELSE
CALL drawborder(XPR, YPR, XPR + XL, YPR + YL, UC, BC, DC)
END IF
V = GetProp(id, PValue)
IF fts = 8 THEN ft = 8 ELSE ft = 10
IF V <> 0 THEN CALL drawpicto(XPR + 2, YPR + 2, ft, 5, UC, BC, Tc, DC)
IF V = 0 THEN CALL drawborder(XPR + 2, YPR + 2, XPR + ft + 2, YPR + ft + 2, UC, BC, DC)

IF st AND CCenter THEN s = 1 ELSE s = 0
CALL PrintInBox(XPR + ft + 5, YPR + 2, X1 - 2, Y1 - 2, tit$, s, Tc, BC)

END IF
'-------------------------------------------OptionBox----------------------------'-----------------------------------------OptionBox----------------------------
IF OBJ = OOptionBox AND RVis <> 0 THEN
IF st AND CNoBorder THEN
ELSE
CALL drawborder(XPR, YPR, XPR + XL, YPR + YL, UC, BC, DC)
END IF
V = GetProp(id, PValue)
IF fts = 8 THEN ft = 8 ELSE ft = 10
IF V <> 0 THEN CALL drawpicto(XPR + 2, YPR + 2, ft, 6, UC, BC, Tc, DC)
IF V = 0 THEN CALL drawborder(XPR + 2, YPR + 2, XPR + ft + 2, YPR + ft + 2, UC, BC, DC)

IF st AND CCenter THEN s = 1 ELSE s = 0
CALL PrintInBox(XPR + ft + 5, YPR + 2, X1 - 2, Y1 - 2, tit$, s, Tc, BC)

END IF
'-------------------------------------------ScrollBar-------------------------'-------------------------------------------ScrollBar----------------------------
IF OBJ = OScrollBar AND RVis <> 0 THEN
st = GetProp(id, PStyle)
max = GetProp(id, PMaxValue)
min = GetProp(id, PMinValue)
V = GetProp(id, PValue)
VW = GetProp(id, PVWidth)

IF V > max THEN V = max
IF V < min THEN V = min

CALL PutProp(id, PValue, V)

IF st = CVertical THEN
IF min > V THEN PutProp id, PValue, min
k# = (max - min + VW) / (YL - XL * 2 - 4)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 1
END IF
CALL drawborder(XPR, YPR + XL, XPR + XL, YPR + YL - XL, DC, DC, UC)
CALL drawpicto(XPR, YPR, XL, 7, UC, BC, Tc, DC)
CALL drawpicto(XPR, YPR + YL - XL, XL, 8, UC, BC, Tc, DC)
CALL drawborder(XPR, kk + YPR + XL, XPR + XL - 1, kk + YPR + Wkk + XL, UC, BC, DC)
END IF
IF st = CHorisontal OR st = 0 THEN
IF min > V THEN PutProp id, PValue, min
k# = (max - min + VW) / (XL - YL * 2 - 4)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 1
END IF
CALL drawborder(XPR + YL, YPR, XPR + XL - YL, YPR + YL, DC, DC, UC)
CALL drawpicto(XPR, YPR, YL, 9, UC, BC, Tc, DC)
CALL drawpicto(XPR + XL - YL, YPR, YL, 10, UC, BC, Tc, DC)
CALL drawborder(XPR + kk + YL, YPR, XPR + kk + Wkk + YL, YPR + YL - 1, UC, BC, DC)

END IF

END IF
'-------------------------------------------TextBox----------------------------'-------------------------------------------TextBox----------------------------
IF (OBJ = OTextBox OR OBJ = OComboBox) AND RVis <> 0 THEN
ROW = GetProp(id, PRow)         'Y
Col = GetProp(id, PCol)         'X
RRow = GetProp(id, PRRow)         'Yr
RCol = GetProp(id, PRCol)         'Xr
SelsRow = GetProp(id, PSelSRow)         'Yr
selSCol = GetProp(id, PSelSCol)         'Xr

ar = GetProp(id, PArray)
SC = GetProp(id, PScrollBar)

IF SC = CVertical THEN VS = -1
IF SC = CHorisontal THEN HS = -1
IF SC = CBoth THEN
VS = -1
HS = -1
END IF
IF OBJ = OComboBox THEN
ar = 0
VS = 0
HS = 0
CB = -1
END IF

TWR = FIX((YL - 2 + HS * 10) / fts)
TWC = FIX((XL - 2 + VS * 10 + CB * 10) / 8) - 1
'-------
IF ROW < 0 THEN ROW = 0
IF Col < 0 THEN Col = 0
IF RRow < 1 THEN RRow = 1
IF RCol < 1 THEN RCol = 1

IF ar <> 0 THEN
        IF st AND CDinamicRows THEN
                Rows = GetFArrRows(ar)
        ELSE
                Rows = GetArrRows(ar)
        END IF
ELSE
        Rows = 1
END IF

RW = RRow - ROW
CW = RCol - Col
'-------
CALL drawFrame(XPR, YPR, XPR + XL - VS, YPR + YL - HS, UC, DC)
yy = YPR + 2
IF ar <> 0 THEN

FOR I = ROW + 1 TO ROW + TWR
s$ = MID$(getarrs(ar, I), Col + 1, TWC + 1)

IF LEN(s$) <= TWC THEN s$ = s$ + SPACE$(TWC - LEN(s$) + 1)

CALL PrintGfx(X + 2, yy, s$, Tc, BC)

IF SelsRow <= I AND RRow >= I AND selSCol <= RCol AND selSCol > 0 AND SelsRow > 0 THEN

IF selSCol > Col THEN CALL PrintGfx(X + 2 + (selSCol - Col) * 8 - 8, yy, MID$(s$, selSCol - Col, RCol - selSCol + 1), BC, Tc)
IF selSCol <= Col THEN CALL PrintGfx(X + 2, yy, MID$(s$, 1, RCol - Col), BC, Tc)
ELSEIF SelsRow <= I AND RRow >= I AND selSCol = 0 AND SelsRow > 0 THEN
CALL PrintGfx(X + 2, yy, s$, BC, Tc)
END IF
yy = yy + fts
NEXT

IF id = focus.id THEN
yy = RW * fts - fts + 2
XX = CW * 8 - 6

s$ = MID$(getarrs(ar, RRow), RCol, 1)
IF s$ = "" THEN s$ = "_"
CALL PrintGfx(XPR + XX, YPR + yy, s$, BC, Tc)
END IF

IF VS THEN
min = 0
max = Rows - TWR
V = ROW
VW = TWR
k# = (max - min + VW) / (YL - (10 * 2 - HS * 10) - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 2
END IF
CALL drawborder(XPR + XL - 10, YPR + 11, XPR + XL, YPR + YL + HS * 10 - 11, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(XPR + XL - 10, YPR + 1, 10, 7, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(XPR + XL - 10, YPR + YL + HS * 10 - 11, 10, 8, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(XPR + XL - 10, kk + YPR + 10, XPR + XL - 1, kk + YPR + Wkk + 10, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF
IF HS THEN
min = 0
max = GetArrCols(ar) - TWC - 1
V = Col
VW = TWC

k# = (max - min + VW) / (XL - 10 * 2 + VS * 10 - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 2
END IF
CALL drawborder(XPR + 10, YPR + YL - 10, XPR + XL + VS * 10 - 10, YPR + YL, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(XPR + 1, YPR + YL - 10, 10, 9, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(XPR + XL + VS * 10 - 11, YPR + YL - 10, 10, 10, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(XPR + kk + 10, YPR + YL - 10, XPR + kk + Wkk + 10, YPR + YL - 1, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF

ELSE

s$ = MID$(title(id), Col + 1, TWC + 1)
IF LEN(s$) <= TWC THEN s$ = s$ + SPACE$(TWC - LEN(s$) + 1)

CALL PrintGfx(X + 2, yy, s$, Tc, BC)

IF selSCol < RCol AND selSCol > 0 THEN
IF selSCol > Col THEN CALL PrintGfx(XPR + 2 + (selSCol - Col) * 8 - 8, yy, MID$(s$, selSCol - Col, RCol - selSCol + 1), BC, Tc)
IF selSCol <= Col THEN CALL PrintGfx(XPR + 2, yy, MID$(s$, 1, RCol - Col), BC, Tc)

END IF
IF id = focus.id THEN
s$ = MID$(title(id), RCol, 1)

IF s$ = "" THEN s$ = "_"
XX = CW * 8 - 6
CALL PrintGfx(XPR + XX, YPR + 2, s$, BC, Tc)

END IF
IF CB THEN
CALL drawpicto(XPR + XL - YL + 1, YPR + 1, YL - 2, 8, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
END IF


END IF


END IF
'-------------------------------------------ListBox----------------------------'-------------------------------------------ListBox----------------------------
IF OBJ = OListBox AND RVis <> 0 THEN
ROW = GetProp(id, PRow)         'Y
Col = GetProp(id, PCol)         'X
RRow = GetProp(id, PRRow)         'Yr
RCol = GetProp(id, PRCol)         'Xr

SelIndex = GetProp(id, PSelIndex)         'Yr

ar = GetProp(id, PArray)
SC = GetProp(id, PScrollBar)
cols = GetProp(id, PCols)
colw = GetArrCols(ar)

IF st AND CDinamicRows THEN
Rows = GetFArrRows(ar)
FRows = Rows
IF cols < 1 THEN cols = 1

DO UNTIL Rows \ cols = Rows / cols
Rows = Rows + 1
LOOP
ELSE
Rows = GetArrRows(ar)
FRows = Rows
DO UNTIL Rows \ cols = Rows / cols
Rows = Rows - 1
LOOP

END IF
PutProp id, PRows, Rows
PutProp id, PCols, cols

IF SC = CVertical THEN VS = -1
IF SC = CHorisontal THEN HS = -1
IF SC = CBoth THEN
VS = -1
HS = -1
END IF


TWR = FIX((YL - 2 + HS * 10) / fts)
TWC = FIX((XL - 2 + VS * 10) / 8)' - 1
'-------
IF ROW < 0 THEN ROW = 0
IF Col < 0 THEN Col = 0
IF RRow < 1 THEN RRow = 1
IF RCol < 1 THEN RCol = 1
RW = RRow - ROW
CW = RCol - Col
'-------

Index = (RRow - 1) * (cols) + RCol

IF Index > FRows THEN
RW = TWR

IF RW > FIX(FRows / cols) THEN
RW = FIX(FRows / cols)
ROW = 0
ELSE
ROW = (FRows / cols) - RW
END IF

RRow = ROW + RW
PutProp id, PRRow, RRow
PutProp id, PRow, ROW
END IF

IF ROW > Rows / cols THEN
RW = 1'TWR
ROW = (Rows / cols) '- RW
RRow = ROW + RW
END IF

IF RCol > cols THEN
CW = WCols
Col = cols - CW
RCol = Col + CW
END IF

'-------
CALL drawFrame(XPR, YPR, XPR + XL - VS, YPR + YL - HS, UC, DC)

yy = YPR + 2
XX = XPR + 2

FOR R = ROW TO ROW + TWR - 1
Y = yy + (R - ROW) * fts
CALL Future.FILLBOX(XPR + 1, Y - 1, XPR + XL + VS * 10 - 1, Y + fts, BC)

FOR C = Col TO Col + cols - 1
IF FIX((C - Col + 1) * colw) > TWC AND cols > 1 THEN EXIT FOR
s$ = SPACE$(colw - 1)
sa$ = ""

I = R * (cols) + C + 1

IF I <= Rows THEN sa$ = getarrs(ar, I)
MID$(s$, 1, LEN(sa$)) = sa$
X = XX + (C - Col) * colw * 8
Y = yy + (R - ROW) * fts
IF LEN(s$) > TWC AND cols = 1 THEN
s$ = MID$(s$, 1, TWC)
END IF
IF R = RRow - 1 AND C = RCol - 1 THEN
CALL PrintGfx(X, Y, s$, BC, Tc)
ELSE
CALL PrintGfx(X, Y, s$, Tc, -1)
END IF

IF SelIndex <> 0 THEN
IF I >= SelIndex AND I <= Index THEN
CALL PrintGfx(X, Y, s$, BC, Tc)
END IF
END IF

NEXT
NEXT
'CALL Future.FILLBOX(xPr + 1, Y + fts, xPr + XL + VS * 11 - 1, Ypr + YL + VS * 11 - 1, BC)

min = 0
IF VS THEN
max = FIX((Rows / cols)) - TWR
V = ROW
VW = TWR
k# = (max - min + VW) / (YL - (10 * 2 - HS * 10) - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2

kk = (V - min) / k# + 2
END IF
CALL drawborder(XPR + XL - 10, YPR + 11, XPR + XL, YPR + YL + HS * 10 - 11, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(XPR + XL - 10, YPR + 1, 10, 7, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(XPR + XL - 10, YPR + YL + HS * 10 - 11, 10, 8, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(XPR + XL - 10, kk + YPR + 10, XPR + XL - 1, kk + YPR + Wkk + 10, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF

IF HS THEN
min = 0
max = cols - FIX(TWC / colw)
V = Col
VW = 1

k# = (max - min + VW) / (XL - 10 * 2 + VS * 10 - 6)
IF k# <> 0 THEN
Wkk = VW / k# + 2
kk = (V - min) / k# + 2
END IF
CALL drawborder(XPR + 10, YPR + YL - 10, XPR + XL + VS * 10 - 10, YPR + YL, Sys.DownColor, Sys.DownColor, Sys.UpColor)
CALL drawpicto(XPR + 1, YPR + YL - 10, 10, 9, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
CALL drawpicto(XPR + XL + VS * 10 - 11, YPR + YL - 10, 10, 10, Sys.UpColor, Sys.BColor, Sys.TColor, Sys.DownColor)
IF max > 0 THEN CALL drawborder(XPR + kk + 10, YPR + YL - 10, XPR + kk + Wkk + 10, YPR + YL - 1, Sys.UpColor, Sys.BColor, Sys.DownColor)
END IF



END IF
'-------------------------------------Menu-----------------------------------------------------Menu--------------------------------------------Menu------------------------------------
IF OBJ = OMenu AND RVis <> 0 THEN
REDIM mnu(25) AS STRING

TLE = LEN(tit$)
CALL drawborder(XPR, YPR, XPR + XL, YPR + YL, UC, BC, DC)

I = 1
DO
il = INSTR(I, tit$, "&") - I

IF il > 0 THEN l = il
s$ = MID$(tit$, I, l)
I = I + l + 1
mnu(k) = s$
k = k + 1
LOOP UNTIL I >= TLE
X = 0
l = 0
V = GetProp(id, PValue)
FOR I = 0 TO k - 1

X = X + l + 1
l = LEN(mnu(I)) * 8 + 16
X1 = X + l
IF V = I + 1 AND (GetProp(id, PLMHold) OR GetProp(id, PLMDown)) THEN
CALL drawborder(XPR + X, YPR, XPR + X1, YPR + YL, DC, BC, UC)
CALL PrintGfx(XPR + X + 9, YPR + 3, mnu(I), Tc, -1)
ELSE
CALL drawborder(XPR + X, YPR, XPR + X1, YPR + YL, UC, BC, DC)
CALL PrintGfx(XPR + X + 8, YPR + 2, mnu(I), Tc, -1)
END IF

NEXT
END IF
IF OBJ = OPictureBox AND RVis <> 0 THEN

IF st AND CNoBorder THEN
ELSE
CALL drawborder(XPR, YPR, XPR + XL, YPR + YL, UC, BC, DC)
END IF

SetViewPort XPR + 1, YPR + 1, XPR + XL, YPR + YL
XX = GetProp(id, PImgXPos)
yy = GetProp(id, PImgYPos)
X = XPR + XX + 1
Y = YPR + XX + 1
IF LEN(tit$) > 4 THEN
IF UCASE$(RIGHT$(tit$, 4)) = ".BMP" THEN CALL Future.LoadBMP(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".PCX" THEN CALL Future.LoadPCX(tit$, X, Y)
IF UCASE$(RIGHT$(tit$, 4)) = ".GIF" THEN CALL Future.LoadGIF(tit$, X, Y)
END IF
SetViewPort 0, 0, Sys.MaxX, Sys.MaxY

END IF
'======================================================================-

CALL PutProp(id, PNoRefresh, 1)
END SUB

